import { defineComponent as f, withDirectives as v, openBlock as l, createElementBlock as o, renderSlot as d, vShow as m, normalizeClass as h, createElementVNode as c, Fragment as $, renderList as g, normalizeStyle as k, createTextVNode as y, toDisplayString as _ } from "vue";
const p = (e, t) => {
  const s = e.__vccOpts || e;
  for (const [a, n] of t)
    s[a] = n;
  return s;
}, j = f({
  name: "Tab",
  props: {
    title: {
      type: String,
      default: "Tab"
    },
    active: {
      type: Boolean,
      default: !1
    },
    hidden: {
      type: Boolean,
      default: !1
    }
  },
  data() {
    return {
      isActive: !1
    };
  },
  mounted() {
    this.isActive = this.active, this.$parent.registerTab(this);
  },
  unmounted() {
    this.$parent.unregisterTab(this);
  }
});
function A(e, t, s, a, n, T) {
  return v((l(), o("div", null, [
    d(e.$slots, "default")
  ], 512)), [
    [m, e.isActive]
  ]);
}
const u = /* @__PURE__ */ p(j, [["render", A]]), C = f({
  name: "Tabs",
  props: {
    /**
     * Index of current tab, use with v-model.
     */
    modelValue: {
      type: Number,
      default: null
    },
    /**
     * Border color for active tab
     */
    activeColor: {
      type: String,
      default: "red"
    },
    /**
     * If true, the tabs will spread over the available space.
     */
    fill: {
      type: Boolean,
      default: !1
    },
    /**
     * Needed if `flex` is true and it is expected that number of tabs will exceed one row.
     */
    fillMinWidth: {
      type: String,
      default: "0"
    },
    /**
     * If true, borders will be shown. Alternatively, you can provide a string that contains one or more of "top", "right", "bottom", "left" for partial borders.
     *
     * Override the CSS class `jskos-vue-tabs-border-{all|top|right|bottom|left}` to adjust borders.
     */
    borders: {
      type: [Boolean, String],
      default: !1
    },
    /**
     * Size of table. One of `sm`, `md`, `lg`.
     */
    size: {
      type: String,
      default: null
    }
  },
  emits: ["update:modelValue", "change"],
  data() {
    return {
      activeTab: null,
      activeTabIndex: 0,
      tabs: []
    };
  },
  computed: {
    _size() {
      return ["sm", "md", "lg"].includes(this.size) ? this.size : "md";
    },
    rootClasses() {
      let e = "jskos-vue-tabs-border-", t = {
        "jskos-vue-tabs": !0,
        [`jskos-vue-tabs-${this._size}`]: !0
      };
      if (this.borders === !1)
        return t;
      if (this.borders === !0)
        return t[`${e}all`] = !0, t;
      for (let s of ["top", "right", "bottom", "left"])
        this.borders.includes(s) && (t[`${e}${s}`] = !0);
      return t;
    },
    hiddenTabs() {
      return this.tabs.map((e) => e.hidden);
    }
  },
  // TODO: For certain changes, all of these watchers apply and call activeTab. It might not be an issue, but it's not efficient.
  watch: {
    tabs(e) {
      let t = e.findIndex((s) => this.activeTab == s);
      t = t == -1 ? this.modelValue !== null ? this.modelValue : this.activeTabIndex : t, this.activateTab(t);
    },
    modelValue(e) {
      this.activateTab(e);
    },
    hiddenTabs() {
      this.activateTab(this.activeTabIndex);
    }
  },
  methods: {
    registerTab(e) {
      const t = Array.from(this.$refs.tabs.children).indexOf(e.$el);
      this.tabs = [
        ...this.tabs.slice(0, t),
        e,
        ...this.tabs.slice(t)
      ], e.isActive && this.activateTab(t);
    },
    unregisterTab(e) {
      this.tabs = this.tabs.filter((t) => t != e);
    },
    activateTab(e) {
      if (this.tabs.length > 0) {
        e >= this.tabs.length && (e = this.tabs.length - 1);
        let t = 0;
        for (; e - t >= 0 || e + t < this.hiddenTabs.length; ) {
          if (this.hiddenTabs[e + t] === !1) {
            e = e + t;
            break;
          }
          if (this.hiddenTabs[e - t] === !1) {
            e = e - t;
            break;
          }
          t += 1;
        }
        for (let a of this.tabs)
          a.isActive = !1;
        let s = this.tabs[e];
        s.isActive = !0, (this.activeTab != s || this.activeTabIndex != e) && (this.activeTab = s, this.activeTabIndex = e, this.$emit("update:modelValue", e), this.$emit("change", { index: e, tab: s }));
      }
    }
  }
}), S = { class: "jskos-vue-tabs-header" }, V = ["onClick"], z = {
  ref: "tabs",
  class: "jskos-vue-tabs-content"
};
function I(e, t, s, a, n, T) {
  return l(), o("div", {
    ref: "root",
    class: h(e.rootClasses)
  }, [
    c("div", S, [
      (l(!0), o($, null, g(e.tabs, (i, r) => v((l(), o("div", {
        key: `jskos-vue-tabs-${r}`,
        class: h(["jskos-vue-tabs-header-item", {
          "jskos-vue-tabs-header-item-active": i.isActive,
          "jskos-vue-tabs-header-item-inactive": !i.isActive,
          "jskos-vue-tabs-header-item-fill": e.fill
        }]),
        style: k({
          "flex-basis": e.fill ? e.fillMinWidth : "auto",
          "border-bottom-color": e.activeColor
        }),
        onClick: (B) => e.activateTab(r)
      }, [
        d(e.$slots, "title", {
          tab: i,
          index: r
        }, () => [
          y(_(i.title), 1)
        ], !0)
      ], 14, V)), [
        [m, !e.hiddenTabs[r]]
      ])), 128))
    ]),
    c("div", z, [
      d(e.$slots, "default", {}, void 0, !0)
    ], 512)
  ], 2);
}
const b = /* @__PURE__ */ p(C, [["render", I], ["__scopeId", "data-v-65d359a5"]]), N = (e) => {
  e.component(b.name, b), e.component(u.name, u);
};
export {
  u as Tab,
  b as Tabs,
  N as install
};
